#!/usr/bin/perl
#

use strict;
use warnings;
use Fcntl;
use IO::File;
use English;

#my $dir      = $ARGV[0];
my $dir = "LOCK4";

my $log_file = $dir.'/'.'test-lock.log';
my $cpt;
my $cpt_file = $dir.'/'.'test-lock.txt';
my $stp_file = $dir.'/'.'stop';


# creer repertoire et fichiers si necessaire
mkdir $dir if (! -e $dir);
if (! -e $cpt_file)
{
    my $cpt_file_fh = new IO::File(">$cpt_file") or die "houlala je peux pas ouvrir $cpt_file en ecriture";
    print $cpt_file_fh "0\n";
}


# boucle infinie - pour en sortir, creer le fichier stop
while(1)
{
    # Calcul du stamp    
    my $stamp = &CalcStamp();

    # Verrouillage du repertoire
    &LockDir($dir);
    
    # Lecture du compteur
    my $warn="";
    if (-z $cpt_file)
    {
        my $log_file_fh = new IO::File(">>$log_file") or die "houlala je peux pas ouvrir $log_file en ecriture";
        print $log_file_fh "$stamp - HOULALA FICHIER COMPTEUR NUL\n";
    }

    my $cpt_file_fh = new IO::File($cpt_file) or die "houlala je peux pas ouvrir $cpt_file en lecture";
    my $cpt = <$cpt_file_fh>;
    if (defined $cpt)
    {
       chomp($cpt);
    }
    else
    {
        my $log_file_fh = new IO::File(">>$log_file") or die "houlala je peux pas ouvrir $log_file en ecriture";
        print $log_file_fh "$stamp - COMPTEUR REMIS A ZERO\n";
        $cpt = 0;
    }


    $cpt_file_fh = '';
    
    # Ecriture dans un fichier log
    my $log_file_fh = new IO::File(">>$log_file") or die "houlala je peux pas ouvrir $log_file en ecriture";
    print $log_file_fh "$stamp - REPERTOIRE VERROUILLE\n";
    
    # Incrementation du compteur
    $cpt++;
    
    # Sauvegarde du compteur
    $cpt_file_fh = new IO::File(">$cpt_file") or die "houlala je peux pas ouvrir $cpt_file en lecture";
    print $cpt_file_fh "$cpt\n";
    $cpt_file_fh = '';
    
    # Ecriture dans le log
    print $log_file_fh "$stamp - COMPTEUR INCREMENTE $cpt\n";
    print $log_file_fh "$stamp - REPERTOIRE BIENTOT DEVERROUILLE\n";
    
    # Deverrouillage du repertoire
    &UnLockDir($dir);
    
    # Faut-il continuer ?
    exit(0) if (-e $stp_file);
    
    # Attendre 1 s
    #sleep(1);
    &WaitRand();
}

sub WaitRand
{
   my $value = rand(1000000);
   for (my $i=0;$i<$value;$i++){};
}
 
sub LockDir
{
    my $dir = shift;
    my $semaphore= $dir.'/.lock';
    open(L,"+>>$semaphore") or die "Cannot open $semaphore";
    fcntl(L,F_SETLKW,pack('ssx32',F_WRLCK,0)) or die "Can't put a write lock on $semaphore: $!";
}


sub UnLockDir
{
    my $dir = shift;
    my $semaphore= $dir.'/.lock';
    fcntl(L,F_SETLKW,pack('ssx32',F_UNLCK,0)) or die "Can't release the write lock on $semaphore: $!";
    close(L);
}


sub CalcStamp
{
    my $self = shift;
    my ($sec, $min, $hour, $mday, $mon, $year) = gmtime();
    $year = (1900 + $year) % 2000;    # We'll have to modify this before 2100
    $mon++;
    my $stamp_time = sprintf("#%02i#%02i#%02i#%02i#%02i#%02i#", $year, $mon, $mday, $hour, $min, $sec);

    my $stamp_pid = $PID;
    my $stamp_host = `hostname`;
    chomp($stamp_host);
    
    return sprintf("%s%06i#%10s", $stamp_time, $stamp_pid, $stamp_host);
}                


