#!/usr/bin/perl

#
# $Id
#

# Copyright INRA

# Erika.Sallet@toulouse.inra.fr
# Jerome.Gouzy@toulouse.inra.fr
# Thomas.Schiex@toulouse.inra.fr

# This software is governed by the CeCILL license under French law and
# abiding by the rules of distribution of free software.  You can  use,
# modify and/ or redistribute the software under the terms of the CeCILL
# license as circulated by CEA, CNRS and INRIA at the following URL
# "http://www.cecill.info".

# As a counterpart to the access to the source code and  rights to copy,
# modify and redistribute granted by the license, users are provided only
# with a limited warranty  and the software's author,  the holder of the
# economic rights,  and the successive licensors  have only  limited
# liability.

# In this respect, the user's attention is drawn to the risks associated
# with loading,  using,  modifying and/or developing or reproducing the
# software by the user in light of its specific status of free software,
# that may mean  that it is complicated to manipulate,  and  that  also
# therefore means  that it is reserved for developers  and  experienced
# professionals having in-depth computer knowledge. Users are therefore
# encouraged to load and test the software's suitability as regards their
# requirements in conditions enabling the security of their systems and/or
# data to be ensured and,  more generally, to use and operate it in the
# same conditions as regards security.

# The fact that you are presently reading this means that you have had
# knowledge of the CeCILL license and that you accept its terms.

=pod 

=cut


BEGIN
{
	$ENV{LANG} = "C";

	use Cwd 'abs_path';
	use File::Basename;
	my ($dirprg) =  dirname(abs_path($0));
	unshift(@INC,"$dirprg/../../../corelib");
}

use strict;
use Carp;
use ParamParser;
use General;
use GeneralBioinfo;

MAIN:
{
    my $o_param = New ParamParser('GETOPTLONG',\&Usage,'fof=s', 'in_ext=s', 'out_ext=s');

    $o_param->AssertFileExists('fof');
    $o_param->AssertDefined('in_ext', 'out_ext');
    
    
    my $pgr =  $ENV{EGNEP}."/bin/int/misc/filter_transcript_incoherent_intron.pl";
    my $in_ext  = $o_param->Get('in_ext');
    my $out_ext = $o_param->Get('out_ext');
    
    my $f_ = $o_param->GetStreamIn('fof');
    while (my $seq = <$f_>)
    {
	chomp($seq);
	print $seq;
	my $cmd = "$pgr --in $seq.$in_ext.gff3 --out $seq.$out_ext.gff3";
	print $cmd."\n";
	system($cmd);
	
    }
}

sub Usage
{
    print STDERR<<END
filter intron incoherence
$0
Mandatory
   --fof
   --in_ext  text    Example: "est6"
   --out_ext text    Example: "est7"
Optional
END
}
