#
# Data for the SeqOntology.pm module
#
# See http://www.sequenceontology.org
# 
#
# %H_SEQ_ONTOLOGY_TYPE connects the sequence ontology terms and the classes used in BioFileConverter
# All the classes should derive from Locus
# Several terms may correspond to a class, thus the value is a "set of values", implemented with a perl hash
# key   = the classes derived from Locus (Locus::XXX)
# Value = sets of names, the possible gene ontology terms

%H_SEQ_ONTOLOGY_TYPE = ( 'Locus::Gene'       => { gene => 1, protein_coding_gene => 1, ncRNA_gene => 1 },
						 'Locus::Mrna'       => { mRNA => 1 },
						 'Locus::Exon'       => { exon => 1 },
						 'Locus::CdsRegion'  => { CDS  => 1 },
						 'Locus::MiscRegion' => { region => 1, primary_transcript => 1, transcript_region => 1, tRNA_primary_transcript => 1, insertion_site => 1, insertion_sequence => 1,DNA_transposon => 1,
												retrotransposon => 1,integron => 1,non_LTR_retrotransposon => 1, SINE_element => 1, LINE_element => 1, MITE => 1, pseudogene => 1, gap => 1, pseudogenic_exon => 1, 
												match => 1, match_part => 1, protein_match => 1, EST_match => 1 },
						 'Locus::Ncrna'      => { ncRNA => 1, scRNA => 1, rRNA => 1, tRNA => 1, snRNA => 1, snoRNA => 1, miRNA => 1, 
												small_regulatory_ncRNA => 1, RNA_6S => 1, CsrB_RsmB_RNA => 1, DsrA_RNA => 1, OxyS_RNA => 1,
												RNase_MRP_RNA => 1, RNase_P_RNA => 1, RprA_RNA => 1, RRE_RNA => 1, spot_42_RNA => 1, telomerase_RNA => 1,
												vault_RNA => 1, Y_RNA => 1, rasiRNA => 1, tmRNA => 1, SRP_RNA => 1, guide_RNA => 1,
												antisense_RNA => 1, siRNA => 1, stRNA => 1, class_II_RNA => 1, class_I_RNA => 1, piRNA => 1, nc_primary_transcript => 1 },
						 'Locus::Repeat'     => { repeat_region => 1, long_terminal_repeat => 1, engineered_foreign_repetitive_element => 1, inverted_repeat => 1, direct_repeat => 1,
												non_LTR_retrotransposon_polymeric_tract => 1, dispersed_repeat => 1, tandem_repeat => 1, repeat_fragment => 1,
												X_element_combinatorial_repeat => 1, Y_prime_element => 1, telomeric_repeat => 1 },
						 'Locus::UtrRegion'  => { UTR => 1, five_prime_UTR => 1, three_prime_UTR => 1 }
						 );
						 
%H_SEQ_ONTOLOGY_PARENT = ( pseudogenic_exon => 'pseudogenic_transcript',
							pseudogenic_transcript => 'pseudogene',
							match_part => 'match' );
							
%H_SEQ_ONTOLOGY_PREFERRED_CHILD = ( pseudogene => 'pseudogenic_exon' );

