package Global;
use Logger;

#This package provide sevaral function used in programs of pipelines.

=head2 procedure LoadParamParser

    Title        : LoadParamParser
    Usage        : ($EGNP, $EUGENEDIR)=&LoadParamParser(\$o_param);
    Prerequisite : none
    Procedure    : Load ParamParser from Environement, then variable from global cfg and overwrite data from parameters cfg.
    Returns      : none
    Args         : Reference on a ParamParser object.
		   $mode : Of update ParamParser with cfg parameter for getopt.
    Globals      : none

=cut 

sub LoadParamParser 
{
	my ($ro_param, $mode)= @_;
	
	$mode="A" if (! defined($mode) );
	$$ro_param->SetBehaviour('ignore_space');
	# From environment

	$$ro_param->Update('ENV', "A");
	$$ro_param->AssertDirExists('EGNP');
	my $egnp=$$ro_param->Get('EGNP');
	$$ro_param->AssertDirExists('EUGENEDIR');
	my $eugenedir=$$ro_param->Get('EUGENEDIR');

	#  parameters ...
	$$ro_param->Update($$ro_param->Get('cfg'), $mode) if ($$ro_param->IsDefined('cfg'));

	my $global_cfg=$egnp."/cfg/global.cfg"; 
	$$ro_param->Update($global_cfg, "A") if (-e $global_cfg );
	
	$$ro_param->SetUnlessDefined('uniq_name',&GetUniqueName);
# 	#From global.cfg
	$$ro_param->SetSubstitution('%I',\$egnp);
	$$ro_param->SetSubstitution('%E',\$eugenedir);
	$$ro_param->SetBehaviour('use_substitution_table');
	return ($egnp, $eugenedir);
}

sub Exec
{
	my $cmd     = shift;
	my $legend  = shift;
	my $verbose = shift;

	my $is_verbose = 0;
	$is_verbose    = 1 if (defined($verbose) && $verbose);
	if (defined ($legend) && $legend ne "")
	{
		print $legend."\n";
	}
	if (defined ($cmd) && $cmd ne "")
	{
		print $cmd."\n" if ($is_verbose);
		system ($cmd);
	}
}

sub CleanParaloop
{
	($dir , $cmd)=@_;
	my $cpt = 0;
	while ( -e "$dir/PARALOOP_lock" && $cpt < 2 )
	{
		#&Exec('',"Pass $cpt, PARALOOP_lock still exist");
		$cpt++;
		sleep 20;
	}
	if ( $cpt == 2 )
	{
		&Exec("$cmd $dir/PARALOOP_lock","I force the directory removal: $dir/PARALOOP_lock");
	}
}

sub GetDate
{
   my @a_date    = gmtime(time);
   $a_date[5]+= 1900;
   $a_date[4]+=1;
   my $day_date  = sprintf("$a_date[5]-%02d-%02d",$a_date[4],$a_date[3]);
   return ($day_date);
}

sub GetUniqueName
{
	my $process_id=$$;
	my $computer_id=`uname -n`;
	chomp ($computer_id);
	my $date=&GetDate();
	my $unique_name="$computer_id.$date.$process_id";
	return ($unique_name);
}


sub LogAndRun
{
	my ($cmd, $o_logger,$flag, $p)=@_;
        $p='run log cmd' if (! defined ($p) );
        if ($p =~ /stdout/)
        {
            print "$cmd\n";
        }
	if ((defined ($o_logger) && $p =~ /log/))
	{
                my $tolog=$cmd;
                $tolog="CMD: ".$tolog if ($p =~ /cmd/);
		$o_logger->Trace("$tolog\n",'*',$flag);
	}
        if ($p =~ /run/)
        {
	   system ($cmd);
        }

}



1;
